﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Otter;
using Prehistech.Utility;

namespace Prehistech.Entities
{
    class AssaultRifle : Entity
    {
        private Spritemap<string> _spriteMap;
        private bool isOkToDropWeapon = false;

        private double speed = .01f;
        private float decayingnumber = 3;
        private double radianAngle = 0;
        private bool firstbounce = true;
        private bool secondbounce = false;
        private bool thirdbounce = false;
        private bool fourthbounce = false;
        private bool activateremove = false;
        private float triggerremove = 50;
        public static bool donebouncing = false;
        private bool isBouncing = false;

        public AssaultRifle(float x, float y)
        {
            X = x;
            Y = y;
            _spriteMap = new Spritemap<string>(Assets.ASSAULTRIFLE, 32, 32);
            SetHitbox(30, 20, (int)Global.Type.ASSAULTRIFLE);
            Collider.Y = -10;
            Collider.X = -15;
            _spriteMap.CenterOrigin();
            addNewSprites();
            _spriteMap.Play("Left");
            Graphic = _spriteMap;
        }
        public override void Update()
        {
            base.Update();
            if (Global.PlayerSession.Controller.Button("R").Pressed)
            {
                //testing TODO?
            }
            var cn = Global.PlayerSession.Controller;
            if (Global.IsPlayerHoldingAssaultRifle)
            {
                this.Collidable = false;
                if (Global.PlayerCurrentAnim == "walkLeft" || Global.PlayerCurrentAnim == "standLeft")
                {
                    _spriteMap.Play("Left");
                    X = Global.PlayerX + 8;//was 8
                    Y = Global.PlayerY + 30;//was 15
                }
                else if (Global.PlayerCurrentAnim == "walkRight" || Global.PlayerCurrentAnim == "standRight")
                {
                    _spriteMap.Play("Right");
                    X = Global.PlayerX + 35;//was 20
                    Y = Global.PlayerY + 30;//was 15
                }
                else if (Global.PlayerCurrentAnim == "walkUp" || Global.PlayerCurrentAnim == "standUp")
                {
                    _spriteMap.Play("Up");
                    X = Global.PlayerX + 22;//was 5
                    Y = Global.PlayerY + 20;//was 5
                }
                else if (Global.PlayerCurrentAnim == "walkDown" || Global.PlayerCurrentAnim == "standDown")
                {
                    _spriteMap.Play("Down");
                    X = Global.PlayerX + 22;//was 5
                    Y = Global.PlayerY + 50;//was 35
                }
                if (cn.Button("E").Released || cn.Button("RightMouseClick").Released)
                    isOkToDropWeapon = true;
                if ((cn.Button("E").Pressed || cn.Button("RightMouseClick").Pressed) && isOkToDropWeapon)
                {
                    isOkToDropWeapon = false;
                    SoundManager.PlayRequestedSound("_dropWeapon");
                    Global.IsPlayerHoldingAssaultRifle = false;
                    if (_spriteMap.CurrentAnim == "Down")
                        Y = Global.PlayerY + 22;
                    //reset bounce variables.
                    isBouncing = true;
                    firstbounce = true;
                    activateremove = false;
                    donebouncing = false;
                    triggerremove = 50;
                    decayingnumber = 3;
                    speed = Rand.Float(2.0f, 6.0f);
                    float rand = Rand.Float();
                    radianAngle = Rand.Float(1.0f, 2.0f);
                    if (radianAngle < 0) radianAngle += 2 * Math.PI;//turns the value into 2PI so we can get 360 degrees.
                    var angleInDegrees = MathHelper.ToDegrees((float)radianAngle);
                    Console.WriteLine("DEGREES: " + angleInDegrees);
                }
            }
            else
                this.Collidable = true;
            if (isBouncing)
            {

                var colls = Collider.Collide(X, Y, (int)Global.Type.SOLID);
                if (colls != null || X < 16 || X >= Global.MW - 16 || Y < 16 || Y >= Global.MH - 16)
                    X += 0;
                else
                {
                    donebouncing = false;
                    X += (float)speed * (float)Math.Cos(radianAngle);
                    Y -= decayingnumber * (float)Math.Sin(radianAngle);
                    _spriteMap.Angle += 6;
                    decayingnumber -= .1f;
                    if ((Y > Global.PlayerY + 30) && (firstbounce))
                    {
                        firstbounce = false;
                        secondbounce = true;
                        decayingnumber = 2;
                    }
                    else if ((Y > Global.PlayerY + 30) && (secondbounce))
                    {
                        decayingnumber = 1;
                        secondbounce = false;
                        thirdbounce = true;
                    }
                    else if ((Y > Global.PlayerY + 30) && (thirdbounce))
                    {
                        decayingnumber = .5f;
                        thirdbounce = false;
                        fourthbounce = true;
                    }
                    else if ((Y > Global.PlayerY + 30) && (fourthbounce))
                    {
                        fourthbounce = false;
                        activateremove = true;
                        triggerremove = 30;
                    }
                    if (activateremove)
                    {
                        Console.WriteLine("done!");
                        isBouncing = false;
                        donebouncing = true;
                        _spriteMap.Angle = 0;
                        if ((X > Global.PlayerX + 10) && (colls != null))
                            X -= .001f;
                        if ((X < Global.PlayerX + 10) && (colls != null))
                            X += .001f;
                        decayingnumber = 0;
                        triggerremove -= .5f;
                        var colld = Collider.Collide(X, Y, (int)Global.Type.SOLID);
                        if (colld != null || X < 0 || X >= Global.MW || Y < 0 || Y >= Global.MH)
                        {
                            Console.WriteLine("colld: " + colld);
                            X += 0;
                        }
                    }
                }
            }
        }
        public void addNewSprites()
        {
            _spriteMap.Add("Right", new int[] { 0 }, new float[] { 4f, 4f });
            _spriteMap.Add("Left", new int[] { 1 }, new float[] { 4f, 4f });
            _spriteMap.Add("Up", new int[] { 2 }, new float[] { 4f, 4f });
            _spriteMap.Add("Down", new int[] { 3 }, new float[] { 4f, 4f });
        }
        public override void Render()
        {
            base.Render();
            //Collider.Render();
        }
    }
}
