﻿using Otter;
using System;
using Prehistech.Utility;
using Prehistech.entities.bullets;

namespace Prehistech.Entities
{
    class Player : Entity
    {
        private Spritemap<string> _spriteMap;
        //private static Sound death = new Sound(Assets.SFX_DEATH); //todo
        private bool _hMove = true;
        private bool _vMove = true;
        public static bool canPlayerCollide = true;
        public static bool isSpriteMapChanged = false;
        private float _memorySpeed = Global.PlayerSpeed;
        private bool _cu = false;
        private bool _cr = false;
        private bool _cl = false;
        private bool _cd = false;
        private bool _first = true;
        private float _ballCannonKnockbackSpeed = 30.0f;
        private int _knockbackTimer = 0;
        private int _knockbackTimerMax = 10;

        public Player(float x, float y)
        {
            X = x;
            Y = y;
            SetHitbox(16, 20, (int)Global.Type.PLAYER);
            Collider.X = 15;
            Collider.Y = 25;
            loadCorrectSpritemap();
        }

        public void Begin()
        {
            moveCameraToPlayer();
        }

        public override void Update()
        {
            base.Update();
            if (_first)
            {//move the stupid camera. Yes it is stupid. lol
                _first = false;
                moveCameraToPlayer();
            }
            var cn = Global.PlayerSession.Controller;
            Global.PlayerX = this.X;
            Global.PlayerY = this.Y;
            if (isSpriteMapChanged)
                loadCorrectSpritemap();
            Global.PlayerCurrentAnim = _spriteMap.CurrentAnim;

            if (cn.Button("R").Pressed)// this is for testing atm.
            {
                Global.player = null;
                Global.PlayerX = 0.0f;
                Global.PlayerY = 0.0f;
                Global.PlayerSpeed = 3.0f;
                Global.PlayerHealth = 50;
                Global.PlayerCurrentAnim = "";
                Global.IsPlayerHoldingAssaultRifle = true;
                Global.IsPlayerHoldingBallCannon = true;
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new Prehistech.Scenes.TempleMainRoom());
            }

            if (((cn.Button("Space").Down) || cn.Button("LeftMouseClick").Down))
            {
                if (Global.IsPlayerHoldingAssaultRifle)
                {
                    if (Global.PlayerCurrentAnim == "walkLeft" || Global.PlayerCurrentAnim == "standLeft")
                    {
                        Scene.Add(new LeadBullet(X - 10, Y + 22));//was 18 22
                    }
                    else if (Global.PlayerCurrentAnim == "walkRight" || Global.PlayerCurrentAnim == "standRight")
                    {
                        Scene.Add(new LeadBullet(X + 42, Y + 23));//was 45 22
                    }
                    else if (Global.PlayerCurrentAnim == "walkUp" || Global.PlayerCurrentAnim == "standUp")
                    {
                        Scene.Add(new LeadBullet(X + 17, Y + 4));//was 14 0
                    }
                    else if (Global.PlayerCurrentAnim == "walkDown" || Global.PlayerCurrentAnim == "standDown")
                    {
                        Scene.Add(new LeadBullet(X + 17, Y + 57));//was 14 55
                    }
                }
                if (Global.IsPlayerHoldingBallCannon)
                {
                    if (Global.PlayerCurrentAnim == "walkLeft" || Global.PlayerCurrentAnim == "standLeft")
                    {
                        Scene.Add(new GiantRockBall(X - 10, Y + 22));//was 18 22
                    }
                    else if (Global.PlayerCurrentAnim == "walkRight" || Global.PlayerCurrentAnim == "standRight")
                    {
                        Scene.Add(new GiantRockBall(X + 42, Y + 23));//was 45 22
                    }
                    else if (Global.PlayerCurrentAnim == "walkUp" || Global.PlayerCurrentAnim == "standUp")
                    {
                        Scene.Add(new GiantRockBall(X + 17, Y + 4));//was 14 0
                    }
                    else if (Global.PlayerCurrentAnim == "walkDown" || Global.PlayerCurrentAnim == "standDown")
                    {
                        Scene.Add(new GiantRockBall(X + 17, Y + 57));//was 14 55
                    }
                    _knockbackTimer = _knockbackTimerMax;
                }
            }

            #region pressed Keys for animation
            if (cn.Button("A").Pressed || cn.Button("Left").Pressed)//LEFT
                _spriteMap.Play("walkLeft");
            else if (cn.Button("D").Pressed || cn.Button("Right").Pressed)//RIGHT
                _spriteMap.Play("walkRight");
            else if (cn.Button("W").Pressed || cn.Button("Up").Pressed)//UP
                _spriteMap.Play("walkUp");
            else if (cn.Button("S").Pressed || cn.Button("Down").Pressed)//DOWN
                _spriteMap.Play("walkDown");
            #endregion

            #region released keys for animation
            if (cn.Button("A").Released || cn.Button("Left").Released)//if i release left, updownright
            {
                if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
                else if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
            }
            else if (cn.Button("D").Released || cn.Button("Right").Released)//if i release right, updownleft
            {
                if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
            }
            else if (cn.Button("W").Released || cn.Button("Left").Released)//if i release up, rightleftdown
            {
                if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
                else if (cn.Button("S").Down || cn.Button("Down").Down)//and i'm holding down
                    _spriteMap.Play("walkDown");
            }
            else if (cn.Button("S").Released || cn.Button("Down").Released)//if i release down, rightleftup
            {
                if (cn.Button("D").Down || cn.Button("Right").Down)//and i'm holding right
                    _spriteMap.Play("walkRight");
                else if (cn.Button("A").Down || cn.Button("Left").Down)//and i'm holding left
                    _spriteMap.Play("walkLeft");
                else if (cn.Button("W").Down || cn.Button("Up").Down)//and i'm holding up
                    _spriteMap.Play("walkUp");
            }
            #endregion

            #region MOVEMENT!! yay!
            if (_knockbackTimer > 0 && X > 0 && X < Global.MW - 32 && Y > 0 && Y < Global.MH - 42 && (!_cl || !_cr || !_cu || !_cd))
            {
                if (GiantRockBall.AngleInDegrees < 45 || GiantRockBall.AngleInDegrees > 315)
                    X += _ballCannonKnockbackSpeed;
                if (GiantRockBall.AngleInDegrees >= 45 && GiantRockBall.AngleInDegrees < 135)
                    Y += _ballCannonKnockbackSpeed;
                if (GiantRockBall.AngleInDegrees >= 135 && GiantRockBall.AngleInDegrees < 225)
                    X -= _ballCannonKnockbackSpeed;
                if (GiantRockBall.AngleInDegrees >= 225 && GiantRockBall.AngleInDegrees <= 315)
                    Y -= _ballCannonKnockbackSpeed;
                moveCameraToPlayer();
            }
            else
            {
                if (cn.Button("A").Down || cn.Button("Left").Down)//left
                {
                    if (X < 0 || _cl)
                        X -= 0;
                    else
                        X -= Global.PlayerSpeed;
                    _hMove = true;
                }
                else if (cn.Button("D").Down || cn.Button("Right").Down)//right
                {
                    if (X > Global.MW - 32 || _cr)
                        X += 0;
                    else
                        X += Global.PlayerSpeed;
                    _hMove = true;
                }
                else
                    _hMove = false;
                if (cn.Button("W").Down || cn.Button("Up").Down)//up
                {
                    if (Y < 0 || _cu)
                        Y -= 0;
                    else
                        Y -= Global.PlayerSpeed;
                    _vMove = true;
                }
                else if (cn.Button("S").Down || cn.Button("Down").Down)//down
                {
                    if (Y > Global.MH - 42 || _cd)
                        Y += 0;
                    else
                        Y += Global.PlayerSpeed;
                    _vMove = true;
                }
                else
                {
                    _vMove = false;
                }
            }
            #endregion
            stopWalkingAnimations();
            #region Collisions
            if (canPlayerCollide)
            {
                #region CollideWithSolid
                var cSpeed = Global.PlayerSpeed;
                if (_knockbackTimer > 0)
                    cSpeed = _ballCannonKnockbackSpeed;
                else
                    cSpeed = Global.PlayerSpeed;
                var collu = Collider.Collide(X, Y - cSpeed, (int)Global.Type.SOLID);
                //var collum = Collider.Collide(X, Y - cSpeed, (int)Global.Type.BIGROCK);
                var colld = Collider.Collide(X, Y + cSpeed, (int)Global.Type.SOLID);
                //var colldm = Collider.Collide(X, Y + cSpeed, (int)Global.Type.BIGROCK);
                var colll = Collider.Collide(X - cSpeed, Y, (int)Global.Type.SOLID);
                //var colllm = Collider.Collide(X - cSpeed, Y, (int)Global.Type.BIGROCK);
                var collr = Collider.Collide(X + cSpeed, Y, (int)Global.Type.SOLID);
                //var collrm = Collider.Collide(X + cSpeed, Y, (int)Global.Type.BIGROCK);
                //start with checking are you surrounded
                if (collu != null && collr != null && colll != null && colld != null /*||
                    collum != null && collrm != null && colllm != null && colldm != null*/)
                {
                    _cu = true; _cd = true; _cr = true; _cl = true;
                }
                //now check the 4 corners
                else if (collu != null && collr != null/* || collum != null && collrm != null*/)
                {
                    _cu = true; _cd = false; _cr = true; _cl = false;
                }
                else if (collu != null && colll != null/* || collum != null && colllm != null*/)
                {
                    _cu = true; _cd = false; _cr = false; _cl = true;
                }
                else if (collr != null && colld != null/* || collrm != null && colldm != null*/)
                {
                    _cu = false; _cd = true; _cr = true; _cl = false;
                }
                else if (colll != null && colld != null/* || colllm != null && colldm != null*/)
                {
                    _cu = false; _cd = true; _cr = false; _cl = true;
                }
                //now check the up down left right
                else if (collu != null/* || collum != null*/)
                {
                    _cu = true; _cd = false; _cr = false; _cl = false;//collision checks(for movement)
                }
                else if (colld != null/* || colldm != null*/)
                {
                    _cu = false; _cd = true; _cr = false; _cl = false;
                }
                else if (collr != null/* || collr != null*/)
                {
                    _cu = false; _cd = false; _cr = true; _cl = false;
                }
                else if (colll != null/* || colllm != null*/)
                {
                    _cu = false; _cd = false; _cr = false; _cl = true;
                }
                else
                {
                    _cu = false; _cd = false; _cr = false; _cl = false;
                }
                #endregion

                #region CollideWithAssaultRifle
                var cAssaultRifleU = Collider.Collide(X, Y - cSpeed, (int)Global.Type.ASSAULTRIFLE);
                var cAssaultRifleD = Collider.Collide(X, Y + cSpeed, (int)Global.Type.ASSAULTRIFLE);
                var cAssaultRifleL = Collider.Collide(X - cSpeed, Y, (int)Global.Type.ASSAULTRIFLE);
                var cAssaultRifleR = Collider.Collide(X + cSpeed, Y, (int)Global.Type.ASSAULTRIFLE);
                if (cAssaultRifleU != null || cAssaultRifleD != null || cAssaultRifleL != null || cAssaultRifleR != null)
                {
                    if (cn.Button("E").Pressed || cn.Button("RightMouseClick").Pressed)
                    {
                        SoundManager.PlayRequestedSound("_pickUpAssaultRifle");
                        Global.IsPlayerHoldingAssaultRifle = true;
                    }
                }
                #endregion

                #region CollideWithBallCannon
                var cBigRockU = Collider.Collide(X, Y - cSpeed, (int)Global.Type.BALLCANNON);
                var cBigRockD = Collider.Collide(X, Y + cSpeed, (int)Global.Type.BALLCANNON);
                var cBigRockL = Collider.Collide(X - cSpeed, Y, (int)Global.Type.BALLCANNON);
                var cBigRockR = Collider.Collide(X + cSpeed, Y, (int)Global.Type.BALLCANNON);
                if (cBigRockU != null || cBigRockD != null || cBigRockL != null || cBigRockR != null)
                {
                    if (cn.Button("E").Pressed || cn.Button("RightMouseClick").Pressed)
                    {
                        SoundManager.PlayRequestedSound("_pickUpBallCannon", 3.0f);
                        Global.IsPlayerHoldingBallCannon = true;
                    }
                }
                #endregion

                #region CollideWithMoi
                var cMoiU = Collider.Collide(X, Y - cSpeed, (int)Global.Type.MOI);
                var cMoiD = Collider.Collide(X, Y + cSpeed, (int)Global.Type.MOI);
                var cMoiL = Collider.Collide(X - cSpeed, Y, (int)Global.Type.MOI);
                var cMoiR = Collider.Collide(X + cSpeed, Y, (int)Global.Type.MOI);
                if (cMoiU != null || cMoiD != null || cMoiL != null || cMoiR != null)
                {
                    Global.PlayerHealth--;
                    SoundManager.PlayRequestedSound("_playerHurt");
                }
                #endregion

                #region CollideWithCat
                var cCatU = Collider.Collide(X, Y - cSpeed, (int)Global.Type.CATSTATUE);
                var cCatD = Collider.Collide(X, Y + cSpeed, (int)Global.Type.CATSTATUE);
                var cCatL = Collider.Collide(X - cSpeed, Y, (int)Global.Type.CATSTATUE);
                var cCatR = Collider.Collide(X + cSpeed, Y, (int)Global.Type.CATSTATUE);
                if (cCatU != null || cCatD != null || cCatL != null || cCatR != null)
                {
                    Global.PlayerHealth-=5;
                    SoundManager.PlayRequestedSound("_playerHurt");
                }
                #endregion

            }
            #endregion

            #region Timers
            if (_knockbackTimer > 0)
                _knockbackTimer--;
            #endregion

            #region Death
            if (Global.PlayerHealth <= 0)
            {
                SoundManager.PlayRequestedSound("_playerDeath");
                destroy();
            }
            #endregion
        }//end of update
        public void loadCorrectSpritemap()
        {
            isSpriteMapChanged = false;
            Global.PlayerSpeed = _memorySpeed;
            _spriteMap = null;
            _spriteMap = new Spritemap<string>(Assets.PLAYER, 46, 56);
            addNewSprites();
            _spriteMap.Update();
            _spriteMap.Play("standDown");
            Graphic = _spriteMap;
        }
        public void moveCameraToPlayer()
        {
            this.Scene.CameraX = X - 320;// - Game.HalfWidth;
            this.Scene.CameraY = Y - 200;// -Game.HalfHeight;
        }
        #region AddSprites
        public void addNewSprites()
        {
            var hMs = 3f;//horizontal animation speed
            var vMs = 4f;//vertical animation speed
            _spriteMap.Add("standRight", new int[] { 0 }, new float[] { hMs, hMs });
            _spriteMap.Add("standLeft", new int[] { 1 }, new float[] { hMs, hMs });
            _spriteMap.Add("standUp", new int[] { 2 }, new float[] { hMs, hMs });
            _spriteMap.Add("standDown", new int[] { 3 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkRight", new int[] { 4, 5, 6, 7, 8, 9, 0, 10, 11, 12, 13, 14, 0 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkLeft", new int[] { 15, 16, 17, 18, 19, 20, 1, 21, 22, 23, 24, 25, 1 }, new float[] { hMs, hMs });
            _spriteMap.Add("walkUp", new int[] { 26, 27, 28, 31, 30, 29, 2 }, new float[] { vMs, vMs });
            _spriteMap.Add("walkDown", new int[] { 32, 33, 34, 37, 36, 35, 3 }, new float[] { vMs, vMs });
        }
        #endregion

        public void stopWalkingAnimations()
        {
            if (!_hMove && !_vMove)
            {
                switch (_spriteMap.CurrentAnim)
                {
                    case ("walkLeft"):
                        _spriteMap.Play("standLeft");
                        break;
                    case ("walkRight"):
                        _spriteMap.Play("standRight");
                        break;
                    case ("walkUp"):
                        _spriteMap.Play("standUp");
                        break;
                    case ("walkDown"):
                        _spriteMap.Play("standDown");
                        break;
                    default:
                        break;
                }
            }
        }

        public override void Render()//mainly for testing colliders :D
        {
            base.Render();
            //Collider.Render();
        }

        public void destroy()
        {
            RemoveSelf();
        }
    }
}
